/* global JSONEditor */
/* global ajaxurl */
'use strict';

(() => {
	const submit = document.getElementById('submit');
	const notificationArea = document.getElementById('json_config-notification-area');
	const container = document.getElementById("jsoneditor");
	const options = {'mode': 'code'};

	const editor = new JSONEditor(container, options);
	const content = container.getAttribute('data-content');
	let initial_content = {};

// Try and parse the post content
	try {
		initial_content = JSON.parse(content);
	} catch (e) {
		console.warn('Unable to parse config JSON');
	}

	editor.set(initial_content);

	submit.addEventListener('click', (e) => {
		e.preventDefault();
		let parseError = false;

		const content_input = document.getElementById('json_config_content');

		try {
			content_input.value = JSON.stringify(editor.get());
		} catch(e) {
			parseError = e;
		}

		const formData = new FormData(document.getElementById('json_config-settings-form'));

		fetch(ajaxurl, {
			method: 'post',
			body: formData
		}).then(function(response) {
			return response.json();
		}).then(function(data) {
			let message = '';
			let classname = 'notice';

			if (data.saved) {
				message = 'JSON config saved';
				classname += ' notice-success'
			} else {
				message = 'An unknown error occurred.';
				classname += ' notice-error'
				if(data.errors && data.errors.length > 0) {
					message = `The JSON config contains the following issues:<br /> ${parseError}`;
				}
			}

			const notice = document.createElement('div');
			notice.className = classname;

			const messageEl = document.createElement('p');
			messageEl.innerHTML = message;

			notice.appendChild(messageEl);

			//empty notification area
			while(notificationArea.firstChild) notificationArea.removeChild(notificationArea.firstChild)

			notificationArea.appendChild(notice);

		});
	});
})();