<?php
/**
 * Plugin Name: DMG JSON Config
 * Plugin URI:  https://github.com/ANMedia/dmg-json-config/
 * Description: Register and manage arbitrary JSON configurations using WordPress custom post types
 * Version:     1.0.6
 * Author:      Metro.co.uk
 * Author URI:  https://github.com/ANMedia/dmg-json-config/graphs/contributors
 */

namespace DMG\JSON_Config;

require_once( __DIR__ . '/class-editor.php' );

/**
 * Get a JSON config by key
 *
 * @param string $key The key of the JSON config
 * @return string The retrieved JSON
 */
function get( $key ) {
	$post_id = get_option( $key  . 'config_post' );
	$content = false;

	if ( $post_id ) {
		$post = get_post( $post_id );

		if ( isset( $post ) && is_a( $post, 'WP_Post' ) ) {
			$content = $post->post_content;
		}

		return apply_filters( "dmg_{$key}_json_config", $content );
	}
}
